%{
#include <iostream.h>
#include "parser_types1.h"
%}

%option never-interactive
BLANCS			[\t]+
CHIFFRE 		[0-9]
ENTIER			{CHIFFRE}+
EXPOSANT		([eE][+-]?{ENTIER})
REEL			{ENTIER}("."{ENTIER})?{EXPOSANT}?
LETTER			[A-Za-z]
VARIABLE		{LETTER}({LETTER}|{CHIFFRE})*

%%
{REEL} {inout << "Flex a trouv le rel "<< atof(yytext) << "yytext :"<< yytext <<endl; yylval.Valeur=atof(yytext); return(REAL);}
[-+*/()^;] { inout << "Flex a trouv le signe "<< *yytext <<endl; return *yytext;}
([Ss]"in")|"SIN"   { yylval.Code='S' ; inout << "Flex a trouv Sin "<<endl; return(UNARY_FCT); }
([Cc]"os")|"COS"   { yylval.Code='C' ; inout << "Flex a trouv Cos "<<endl; return(UNARY_FCT);}
([Tt]"an")|"TAN"   { yylval.Code='T' ; return(UNARY_FCT);}
([Aa]"tan")|"ATAN" { yylval.Code='A' ; return(UNARY_FCT);}
([Ee]"xp")|"EXP"   { yylval.Code='E' ; return(UNARY_FCT);}
([Ll]"n")|"LN"	   { yylval.Code='L' ; return(UNARY_FCT);}
([Ss]"qrt")|"SQRT" { yylval.Code='R' ; return(UNARY_FCT);}
([Ss]"qr")|"SQR"   { yylval.Code='2' ; return(UNARY_FCT);}
([Ss]"tep")|"STEP" { yylval.Code='H' ; inout << "Flex a trouv Step "<<endl; return(UNARY_FCT); }
{VARIABLE} {inout << "Flex a trouv la variable "<< *yytext <<endl; strcpy(yylval.Name,yytext); return(VARIABLE);}
%%

int yywrap(void) {return 1 ;}
