//---------------------------------------------------------------------------
// Pour Nicolas :
//   (1)           Mettre glLineWidth(2); avant de tracer en fil de fer car sinon,
//                 on ne voit pas les sparations entre les pavs.
//   (2)           Afin que l'affichage ne ralentisse pas le programme,
//                 il faut utiliser un timer qui tous le OpenGLPanel1Paint secondes,
//                 lance le repaint (voir par exemple le programme de la voiture.



#include <vcl.h>
#include <list.h>
#pragma hdrstop

#include "Unit1.h"
//#include "Thread.h"
#include "sivia.h"
#include "box.h"
#include "expression.h"
#include <vector.h>
#include "parser.c"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "OpenGLPanel"
#pragma resource "*.dfm"
enum TStringFloatFormat {sffGeneral, sffExponent, sffFixed, sffNumber, sffCurrency };
TForm1 *Form1;
box P0;

double e = 0.001;

extern vector <box> L_sivia_IN;
extern vector <box> L_sivia_OUT;
extern vector <box> L_sivia_MB;
extern vector <box> A;
vector <expression> vr_expr;
extern interval seuil;
extern interval a;
extern double alpha;

list <box> L_cur;



vector <Node> arbre_de_node;
vector <Node> arbre_derive;
vector <expression> vr_expr1, vr_expr2;
int Example=0;


//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void traceBoite(box P, float color1,float color2,float color3, float color4,float color5,float color6,bool fils_de_fer)
 {
  glBegin(fils_de_fer ? GL_LINE_LOOP : GL_POLYGON );
  glColor3f(color1,color2,color3);
  glVertex2d(  Inf(P[1]), Inf(P[2])) ;
  glVertex2d(  Sup(P[1]), Inf(P[2])) ;
  glVertex2d(  Sup(P[1]), Sup(P[2])) ;
  glVertex2d(  Inf(P[1]), Sup(P[2])) ;
  glEnd();
  glLineWidth(2);

  if (!(Form1->fils_de_fer_form))
  {
  glBegin(GL_LINE_LOOP);
  glColor3f(color4,color5,color6);
  glVertex3d(  Inf(P[1]), Inf(P[2]),e) ;
  glVertex3d(  Sup(P[1]), Inf(P[2]),e) ;
  glVertex3d(  Sup(P[1]), Sup(P[2]),e) ;
  glVertex3d(  Inf(P[1]), Sup(P[2]),e) ;
  glEnd();
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OpenGLPanel1Init(TObject *Sender)
{
   	glViewport(0,0,(GLsizei)OpenGLPanel1->Width,(GLsizei)OpenGLPanel1->Height);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
    if ( OpenGLPanel1->Height==0)
     	gluPerspective(45, (GLdouble)OpenGLPanel1->Width, 1.0, 2000.0);
    else
        gluPerspective(45, (GLdouble)OpenGLPanel1->Width/
                           (GLdouble)OpenGLPanel1->Height,1.0, 2000.0);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glEnable(GL_DEPTH_TEST);
        glClearColor(1.0,1.0,1.0,0.0);
        xc =0;
        yc =0;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OpenGLPanel1Paint(TObject *Sender)
{
 glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
 glPushMatrix();
 glTranslatef(xc, yc, ol_vue);
 box P;
 glEnable(GL_DEPTH_TEST);
 glPushMatrix();
 box centre = P0.centre_gravite();
 double w =4/P0.width();

 glScaled(w,w,0);
 glTranslated(-Inf(centre[1]), -Inf(centre[2]), 0); //place le dessin X_0 au centre du composant opengl */

 glBegin(GL_LINE_LOOP);
 glColor3f(0,0,0);
 glVertex2d(Inf(P0[1]),Inf(P0[2])) ;
 glVertex2d(Sup(P0[1]),Inf(P0[2])) ;
 glVertex2d(Sup(P0[1]),Sup(P0[2])) ;
 glVertex2d(Inf(P0[1]),Sup(P0[2])) ;
 glEnd();

 if (L_cur.empty()!=true)
{
   list <box>::iterator iter;
   for (iter=L_cur.begin();iter!=L_cur.end();iter++)
   {
    P = *iter;
    traceBoite(P,0,1,1,1,1,1,true);
    }
}

if (L_sivia_MB.empty()!=true)
for (int k=0;k < L_sivia_MB.size();k++)
{
    P = L_sivia_MB[k];
    if (CheckBoxBlackWhite->Checked)
        traceBoite(P,1,1,1,1,1,1,false);
    else
        traceBoite(P,1,1,0,0.9,0.9,0.3,false);
}

if (L_sivia_IN.empty()!=true)
{
   for (int k=0;k < L_sivia_IN.size();k++)
   {
    P = L_sivia_IN[k];
    if (CheckBoxBlackWhite->Checked)
        traceBoite(P,0.4,0.4,0.4,0.0,0.0,0.0,false);
    else
        traceBoite(P,1,0,0,1,0.3,0.3,false);
    }
}
if (L_sivia_OUT.empty()!=true)
for (int k=0;k < L_sivia_OUT.size();k++)
{
    P = L_sivia_OUT[k];
    if (CheckBoxBlackWhite->Checked)
        traceBoite(P,0.8,0.8,0.8,0.7,0.7,0.7,false);
    else
        traceBoite(P,0,0,1,0.3,0.3,1,false);
}

  glPushMatrix();
  glTranslated(Inf(P0[1]), Inf(P0[2])-0.3/w, 0);
  glScaled(1/w,1/w,1);
  glColor3f(0,0,0);
  glScalef(0.4,0.4,0.4);
  AnsiString string = FloatToStrF(Inf(P0[1]),sffGeneral,3,3);
  Form1->OpenGLPanel1->Draw3DText(string);
  glPopMatrix();

  glPushMatrix();
  glTranslated(Sup(P0[1]), Inf(P0[2])-0.3/w, 0);
  glScaled(1/w,1/w,1);
  glColor3f(0,0,0);
  glScalef(0.4,0.4,0.4);
  string = FloatToStrF(Sup(P0[1]),sffGeneral,3,3);
  Form1->OpenGLPanel1->Draw3DText(string);
  glPopMatrix();

  glPushMatrix();
  glTranslated(Inf(P0[1])-0.5/w, Inf(P0[2]), 0);  //0.3
  glScaled(1/w,1/w,1);
  glColor3f(0,0,0);
  glScalef(0.4,0.4,0.4);
  string = FloatToStrF(Inf(P0[2]),sffGeneral,3,3);
  Form1->OpenGLPanel1->Draw3DText(string);
  glPopMatrix();

  glPushMatrix();
  glTranslated(Inf(P0[1])-0.5/w, Sup(P0[2]), 0);
  glScaled(1/w,1/w,1);
  glColor3f(0,0,0);
  glScalef(0.4,0.4,0.4);
  string = FloatToStrF(Sup(P0[2]),sffGeneral,3,3);
  Form1->OpenGLPanel1->Draw3DText(string);
  glPopMatrix();
  glPopMatrix();
  glPopMatrix();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormMouseWheelDown(TObject *Sender,
      TShiftState Shift, TPoint &MousePos, bool &Handled)
{
ol_vue = ol_vue/0.97;
OpenGLPanel1->Repaint();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormMouseWheelUp(TObject *Sender,
      TShiftState Shift, TPoint &MousePos, bool &Handled)
{
if (-0.97*ol_vue > 1.01)
{ol_vue = 0.97*ol_vue;}
OpenGLPanel1->Repaint();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{       P0[1]=interval(EditX1min->Text.ToDouble(),EditX1max->Text.ToDouble());
        P0[2]=interval(EditX2min->Text.ToDouble(),EditX2max->Text.ToDouble());
        ol_vue = -10;
        fils_de_fer_form = false;
        down = false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ButtonStartClick(TObject *Sender)
{
      Memo1->Text="I am now computing, please wait ...";
      TrackBarSeuil->Visible=false;
      ButtonStart->Visible=false;
      LabelWait->Visible=true;

      vr_expr.clear();
      expression expr;
      expr.chaine = EditProbDensity->Text;
      int j = expr.creation_arbre_de_node();
      vr_expr.push_back(expr);

      if (vr_expr.size()==0) {ShowMessage("f(p1,p2) undefined");return;}
      P0[1]=interval(EditX1min->Text.ToDouble(),EditX1max->Text.ToDouble());
      P0[2]=interval(EditX2min->Text.ToDouble(),EditX2max->Text.ToDouble());
      SIVIAfile(P0);
      OpenGLPanel1->Repaint();
      TrackBarSeuil->Visible=true;
      ButtonStart->Visible=true;
      LabelWait->Visible=false;
      CheckBoxBlackWhite->Visible=true;
      TrackBarSeuilChange(Sender);
}

//---------------------------------------------------------------------------

void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{       L_sivia_IN.clear(); L_sivia_OUT.clear(); L_sivia_MB.clear();
        vr_expr.clear();
        L_cur.clear();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OpenGLPanel1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{       down = true;
        x_down = X;   y_down = Y;
        xc_down = xc; yc_down = yc;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::OpenGLPanel1MouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
if (down==true)
{int x_dif=X-x_down;
int y_dif=Y-y_down;
xc = xc_down + 0.01*x_dif;
yc = yc_down - 0.01*y_dif;
OpenGLPanel1->Repaint();}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::OpenGLPanel1MouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
down=false;
}

//---------------------------------------------------------------------------

void MAJMemo1(double alpha)
{
    Form1->Memo1->Text="alpha = "+String(alpha)+" \r\n ";
    Form1->Memo1->Text=Form1->Memo1->Text+ "a = ["+String(a.GetInf())+" , "+String(a.GetSup())+" \r\n ";
    Form1->Memo1->Text=Form1->Memo1->Text+ "Threshold = ["+String(seuil.GetInf())+" , "+String(seuil.GetSup())+" \r\n ";
    Form1->Memo1->Text=Form1->Memo1->Text+"Number of boxes = " + A.size()+" \r\n "  ;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::TrackBarSeuilChange(TObject *Sender)
{       L_sivia_IN.clear(); L_sivia_OUT.clear(); L_sivia_MB.clear();
        alpha=TrackBarSeuil->Position/100.0;
        CalculSeuils(alpha);
        MAJMemo1(alpha);
        Partitionne(0);
        Form1->OpenGLPanel1->Repaint();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonOtherExampleClick(TObject *Sender)
{ Example++;
  switch (Example)
  {
  case 1 : {    EditProbDensity->Text="exp(-sqr(p1)-sqr(p2))";
                EditX1min->Text="-10";EditX1max->Text="10";
                EditX2min->Text="-10";EditX2max->Text="10";
                EditCardinalPaving->Text="1000";
                EditAccuracyIntervalCalculus->Text="5";
                P0[1]=interval(EditX1min->Text.ToDouble(),EditX1max->Text.ToDouble());
                P0[2]=interval(EditX2min->Text.ToDouble(),EditX2max->Text.ToDouble());
                OpenGLPanel1->Repaint();
                break;
           }
  case 2 : {    EditProbDensity->Text="step(p1)*step(p2)";
                EditX1min->Text="-10";EditX1max->Text="10";
                EditX2min->Text="-10";EditX2max->Text="10";
                EditCardinalPaving->Text="1000";
                EditAccuracyIntervalCalculus->Text="5";
                P0[1]=interval(EditX1min->Text.ToDouble(),EditX1max->Text.ToDouble());
                P0[2]=interval(EditX2min->Text.ToDouble(),EditX2max->Text.ToDouble());
                OpenGLPanel1->Repaint();
                break;
           }
  case 3 : {    EditProbDensity->Text="step(p1)*step(p2)*exp(-p1)*exp(-p2)";
                EditX1min->Text="-10";EditX1max->Text="10";
                EditX2min->Text="-10";EditX2max->Text="10";
                EditCardinalPaving->Text="1000";
                EditAccuracyIntervalCalculus->Text="5";
                P0[1]=interval(EditX1min->Text.ToDouble(),EditX1max->Text.ToDouble());
                P0[2]=interval(EditX2min->Text.ToDouble(),EditX2max->Text.ToDouble());
                OpenGLPanel1->Repaint();
                break;
           }
  case 4 : {    EditProbDensity->Text="exp(-2*sqr(0.8-p1*sin(p2))-2*sqr(1-p1*sin(2*p2))-2*sqr(0.2-p1*sin(3*p2)))";
                EditX1min->Text="-2";EditX1max->Text="2";
                EditX2min->Text="0";EditX2max->Text="6";
                EditCardinalPaving->Text="2000";
                EditAccuracyIntervalCalculus->Text="7";
                P0[1]=interval(EditX1min->Text.ToDouble(),EditX1max->Text.ToDouble());
                P0[2]=interval(EditX2min->Text.ToDouble(),EditX2max->Text.ToDouble());
                OpenGLPanel1->Repaint();
                Example=0;
           }
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CheckBoxBlackWhiteClick(TObject *Sender)
{
   OpenGLPanel1->Repaint();
}
//---------------------------------------------------------------------------

