#ifndef __BOX__
#define __BOX__

#include <iostream.h>
#include "interval.h"
#include "vector.h"


class box
{
public:
	box ();
	box (int);
	box (const box&);
	~box ();
	interval& operator[] (int) const ;
	void operator= (const box &);
	void Resize (int);
	interval* data;
	bool isEmpty;
	int dim;
        int pere,fg,fd,number;
        interval F,f;  //F:integrale de f sur la boite
        bool deja_evalue;
        double critere ;//  Pour une procedure de tri.
        int nombre_ascendants;  
//        double aire();
        box sommet(int); //renvoie une boite qui est le k_ieme sommet de la boite P.
        box centre_gravite(); //renvoie une boite qui est le centre de gravit de ma boite.
        double width(); // renvoie la taille de la boite (taille du plus grand interval de la boite)
        double min_width(); // renvoie la taille du plus petit interval de la boite


friend double       Angle       (box&v,box&); // Il faut des vecteurs de dim 2
//rajout par Nico
friend box       Reunion       (box& ,box&); // Il faut des vecteurs de dim 2
friend box       centre_gravite (vector <box> vect); // Il faut des vecteurs de dim 2

friend int	    AxePrincipal(box&);
friend int			AxePrincipal(box&,box&);
friend void			Bisect		(box&, box&,box&);
friend void			BisectAlong	(box&, box&,box&,int);
friend box			Center		(const box&);
friend void			CheckRange	(box&,box&);
friend interval     Determinant (box&, box&);
friend bool		    Disjoint	(const box&,const box&);
friend double         Eloignement (box&,box&);
friend double         Eloignement2(box&,box&);
friend double         EloignementRelatif2(box&,box&);
friend iboolean	    In			(box&,box&);
friend box			Inf 		(box&);
friend box			Inflate 	(box&,double);
friend box			Inter 		(const box&,const box&);
//friend void         Inter1      (box&,box&,const box&,const box&,const box&);
friend interval     Norm        (box&);
friend interval     ProduitScalaire(box&,box&);
friend bool         Prop        (box&,box&);
friend bool			Subset		(box&,box&);
friend bool			Subset		(box&,box&,double);
friend void         Sucre       (box&,box&);
friend box			Sup 		(box&);
friend box  Union (box&,box&);
friend box          Face(box& , vector <iboolean> );
friend double       Volume      (box&);
friend double		Width		(box&);
friend double		Width		(box&,box&);
friend box          Zeros       (int);

friend box	operator+(const box&,const box&);
friend box	operator-(const box&);
friend box	operator-(const box&,const box&);
friend box	operator*(const interval&,const box&);
friend box	operator*(const box&,const interval&);
friend bool     operator<(const box &x, const box &y);
friend ostream& operator<<(ostream&, const box&);
};

#endif
