//---------------------------------------------------------------------------
#include <stdio.h>
#include <stdlib.h>
#include <vcl.h>
#include <list.h>
#include <vector.h>
#include <dstring.h>
#include <algorithm>


#pragma hdrstop

#include "sivia.h"
#include "unit1.h"
#include "box.h"
#include "expression.h"



extern list <box> L_cur;
extern vector <expression> vr_expr;


vector <box> L_sivia_IN;
vector <box> L_sivia_OUT;
vector <box> L_sivia_MB;
vector <box> A;
vector<box> L_f_minus;
vector<box> L_f_plus;


vector <double> x;
vector <double> y;

fstream infostream;

interval seuil(0,99999);
interval a(0,99999);
double alpha=-2;
double AverageWidthProba=1;




//----------------------------------------------------------------------



//---------------------------------------------------------------------------
#pragma package(smart_init)
//----------------------------------------------------------------------




interval f(box& P)
{   interval result=vr_expr[0].Evalue(P[1],P[2]);
    return Max(interval(0,0),result);
};

void CreeFichierScilab()
{    fstream infostream;
     double smin=-0.2;
     double smax=1.2;
     infostream.open("hdes.sce",fstream::out);
     infostream << "xset('font',2,12);" << endl;
     infostream << "s=[];"<<endl;
     infostream << "hmin=[];"<<endl;
     infostream << "hmax=[];"<<endl;

     for (double s=smin;s<=smax;s=s+0.001)
     {  double hmin=0;
        double hmax=0;
        for (int i=0;i<=A.size()-1;i++)
        { if (A[i].fg==-1)
          {  if (Inf(A[i].f)>s)
                {hmin=hmin+(A[i].F.GetInf())/a.GetSup();};
             if (Sup(A[i].f)>s)
                {hmax=hmax+A[i].F.GetSup()/a.GetInf();};
           }
         } ;
         infostream << "s=[s," << s <<"];"<<endl;
         infostream << "hmin=[hmin," << hmin <<"];"<<endl;
         infostream << "hmax=[hmax," << hmax <<"];"<<endl;
     }
         infostream << "plot2d(s,hmin,-3);"<<endl;
         infostream << "plot2d(s,hmax,-3);"<<endl;

         infostream.close();
}


void CalculSeuils(double alpha)
{    //infostream.open("infoSeuils.txt",fstream::out);
     //infostream << "dbut du fichier d'infoSeuils  " << endl;
     int i=0;
     double a_plus=0;
     for (i=L_f_minus.size()-1;(i>=0)&&(a_plus<=alpha*a.GetSup());i--)
     {a_plus=a_plus+L_f_minus[i].F.GetInf();}
     double seuilinf=L_f_minus[i].critere;
     double a_minus=a.GetInf();
     for (i=0;(i<=L_f_plus.size()-1)&&(a_minus>=alpha*a.GetInf());i++)
     {a_minus=a_minus-L_f_plus[i].F.GetSup();}
     double seuilsup=L_f_plus[i].critere;
     //infostream << "i = " << i << "seuilsup =" << seuilsup ;
     seuil = interval(seuilinf,seuilsup);
     //infostream.close();
}

void Tri()
{ L_f_minus.clear();
  L_f_plus.clear();
  for (int i=0;i<=A.size()-1;i++)
     if (A[i].fg==-1) {L_f_minus.push_back(A[i]);L_f_plus.push_back(A[i]);};
  for (int i=0;i<=L_f_minus.size()-1;i++)
     {L_f_minus[i].critere=L_f_minus[i].f.GetInf();L_f_plus[i].critere=L_f_plus[i].f.GetSup();}
  sort(L_f_minus.begin(), L_f_minus.end());
  sort(L_f_plus.begin(), L_f_plus.end());
}

Evalue(box& P)
{   if (P.deja_evalue==false)
    {     P.f=f(P);
          P.F=Volume(P)*P.f;
    }
    P.deja_evalue=true;
}



int Partitionne(int n)       //Partitionne les pavs jaunes, rouges et bleus
{   int fg1=A[n].fg;
    int fd1=A[n].fd;
    if (A[n].f.GetInf()>seuil.GetSup()) {return 1; }
    if (A[n].f.GetSup()<seuil.GetInf()) {return -1; }
    if (Subset(A[n].f,seuil)) {return 0;}
    if (fg1!=-1)
    {  int i1=Partitionne(fg1);
       int i2=Partitionne(fd1);
       if (i1==i2) return i1;
       if (i1==1) {L_sivia_IN.push_back(A[fg1]); }
       else if (i1==-1) {L_sivia_OUT.push_back(A[fg1]); }
       else if (i1==0) {L_sivia_MB.push_back(A[fg1]); };
       if (i2==1) {L_sivia_IN.push_back(A[fd1]); }
       else if (i2==-1) {L_sivia_OUT.push_back(A[fd1]); }
       else if (i2==0) {L_sivia_MB.push_back(A[fd1]); };
    }
}


void RaffineLeaves(box& P,int h)
{     box P1,P2;
      Evalue(P);
        if (h > 0)
      {      Bisect(P,P1,P2);
             RaffineLeaves(P1,h-1);
             RaffineLeaves(P2,h-1);
             P.f=Union(P1.f,P2.f);
             P.F=P1.F+P2.F;
      }
}



void Raffine(int n)             //Raffine les f et F
{   int fg1=A[n].fg;
    int fd1=A[n].fd;
    if (fg1==-1)
    {   if (Width(A[n].F)>AverageWidthProba*0.05)
        {       RaffineLeaves(A[n],Form1->EditAccuracyIntervalCalculus->Text.ToInt());
        }
        return;
    };
    Raffine(fg1);Raffine(fd1);
    A[n].f=Union(A[fg1].f,A[fd1].f);
    A[n].F=A[fg1].F+A[fd1].F;
}


void SIVIAfile(box P)
{   box P1,P2;
   int Nb_de_bisections=0;
   infostream.open("info.txt",fstream::out);
   infostream << "dbut du fichier d'info  " << endl;
   infostream << "-->  Evalue(P) : P = " << P << "   et   P.f = " << P.f << endl;
   AverageWidthProba=1;
    L_cur.clear();
    A.clear();
    L_cur.push_back(P);
    while (!L_cur.empty())
    { P=L_cur.front();
      Form1->Memo1->Text="I am now in the SIVIA procedure \r\n";
      L_cur.pop_front();
      Evalue(P);
//      infostream << "-->  Evalue(P) : P = " << P << "   et   P.f = " << P.f << endl;
      AverageWidthProba=(AverageWidthProba*(L_cur.size())+1*Width(P.F))/(L_cur.size()+1);
      if ((AverageWidthProba>1.5*Width(P.F))&&(Nb_de_bisections<Form1->EditCardinalPaving->Text.ToInt())) L_cur.push_back(P);
        else
      {
        P.number=A.size();
        if (P.pere!=-1)
        {      if (A[P.pere].fg==-1) {A[P.pere].fg=P.number;}
              else   {A[P.pere].fd=P.number;};
        }
        A.push_back(P);
        if (Nb_de_bisections<Form1->EditCardinalPaving->Text.ToInt())
              {   Bisect(P,P1,P2); L_cur.push_back(P1);L_cur.push_back(P2);Nb_de_bisections++;
              }
       }
    }
      Form1->OpenGLPanel1->Repaint();
   infostream << endl<< endl<< "Parcours de l'arbre A dont la taille est " << A.size()<< endl;
   //for (int i=0;i<=A.size()-1;i++)
   //{  infostream << i << "-->  number = " << A[i].number<< ", fg = " << A[i].fg << ", fd = " << A[i].fd;
   //   infostream << ", F = " << A[i].F<< ", densit = " << A[i].f<< endl;
   //}

   Raffine(0);
   a=A[0].F;
   Tri();
   CreeFichierScilab();
   infostream.close();
} ;


